// Vyjimky.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <conio.h>

class ZaporneException
{
public:
	int cislo;

	ZaporneException(int c) : cislo(c)
	{
		printf("Konstruuji vyjimku (%d)\n", c);
	}

	ZaporneException(const ZaporneException & e)
	{
		printf("Konstruuji vyjimku kopirovanim (%d)\n", e.cislo);
		cislo = e.cislo;
	}

	ZaporneException & operator=(const ZaporneException & e)
	{
		printf("Kopiruji vyjimku (%d)\n", e.cislo);
		cislo = e.cislo;
		return *this;
	}

	~ZaporneException()
	{
		printf("Rusim vyjimku (%d)\n", cislo);
	}

};


// vyhazuje vyjimku pokud a < 0
void f(int a)
{
	if (a < 0)
	{
		puts("Vyhazuji vyjimku..");
		throw ZaporneException(a);
	}

	puts("f() probehla bez vyjimky");
}

class NejakaTrida
{
	int * pole;
public:
	NejakaTrida()
	{
		puts("Vytvarim nejakou tridu a alokuji");
		pole = new int[100];
	}

	~NejakaTrida()
	{
		puts("Rusim nejakou tridu a uvolnuji");
		delete[] pole;
	}
};

void g()
{
	// lokalni objekt
	NejakaTrida a;
	// vyhodi vyjimku
	f(-5);

	// a presto, ze byla vyjimka, se NejakaTrida uvolni
}

int _tmain(int argc, _TCHAR* argv[])
{
	puts("Zacatek programu");

	try
	{
		g();
	}
	catch (ZaporneException & vyj)
	{
		printf("Zachycena NejakaVyjimka (%d)\n", vyj.cislo);
	}

	puts("Konec programu.");
	getch();
	return 0;
}

